package Catalyst::Plugin::MessageStack::Sticky;
# ABSTRACT: 振舞いを変更。リダイレクトではなくても、flashへ積む。
$Catalyst::Plugin::MessageStack::Sticky::VERSION = '0.141630';
use Moose::Role;

after dispatch => sub {
    my $c = shift;

    # この場合Catalyst::Plugin::MessageStackは自分でflashに積むのでスキップ。
    return if $c->res->location;

    # resetされていない、積まれているものは全てflashへ。
    my $config = $c->config->{'Plugin::MessageStack'};
    my $stash_key  = $config->{stash_key} || 'messages';
    my $flash_key  = $config->{flash_key} || '_messages';
    my $rflash_key = $config->{results_flash_key} || '_results';
    my $rstash_key = $config->{results_stash_key} || 'results';

    my $messages = $c->stash->{$stash_key};

    if ( $messages and $messages->has_messages and !$c->flash->{$flash_key} ) {
        $c->flash->{$flash_key}    = $messages;
        $c->keep_flash($flash_key);
    }
};

1;

__END__

=pod

=head1 NAME

Catalyst::Plugin::MessageStack::Sticky - 振舞いを変更。リダイレクトではなくても、flashへ積む。

=head1 VERSION

version 0.141630

=head1 AUTHOR

Tomohiro Hosaka <bokutin@bokut.in>

=head1 COPYRIGHT AND LICENSE

This software is copyright (c) 2014 by Tomohiro Hosaka.  No
license is granted to other entities.

=cut
