package TestApp::Controller::Root;

use Moose;
BEGIN { extends 'Catalyst::Controller' }

__PACKAGE__->config(namespace => '');

sub index :Path :Args(0) {
    my ($self, $c) = @_;

    $c->res->body('hello');
}

sub stack :Local :Args(0) {
    my ($self, $c) = @_;

    $c->message('msg1');
    $c->message->reset if $c->req->param('reset');
    return $c->res->redirect( $c->uri_for('/') ) if $c->req->param('redirect');

    $c->res->body('stacked');
}

sub count :Local :Args(0) {
    my ($self, $c) = @_;

    my $num = $c->message->count;

    $c->res->body($num);
}

sub reset :Local :Args(0) {
    my ($self, $c) = @_;

    $c->message->reset;

    $c->res->body("reseted");
}

__PACKAGE__->meta->make_immutable;
1;
